<?php
# Copyright (C) 2008	John Reese
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

function map( $func, $list ) {
	$new_list = array();

	foreach( $list as $key => $item ) {
		$new_list[$key] = call_user_func( $func, $item );
	}

	return $new_list;
}

function twomap( $func, $list ) {
	$new_list2 = array();
	$new_list = array();

	foreach( $list as $key => $item ) {
		list( $new_list[$key], $new_list2[$key] ) = call_user_func( $func, $key, $item );
	}

	return array( $new_list, $new_list2 );
}

function filter( $func, $list ) {
	$new_list = array();

	foreach( $list as $key => $item ) {
		if ( call_user_func( $func, $item ) ) {
			$new_list[$key] = $item;
		}
	}

	return $new_list;
}

function filterout( $func, $list ) {
	$new_list = array();

	foreach( $list as $key => $item ) {
		if ( ! call_user_func( $func, $item ) ) {
			$new_list[$key] = $item;
		}
	}

	return $new_list;
}

